Added escaping of double quotes that were added previously
[matthijs/upstream/backupninja.git] / handlers / pgsql
index 63062f7084175454940c4eff9be561f73d991a54..940f16b475a570f2fb52c3538fe321c6be269570 100644 (file)
@@ -10,47 +10,48 @@ getconf vsname
 
 localhost=`hostname`
 
-# If vservers are configured, decide if the handler should
-# use them or if it should just operate on the host
+# Decide if the handler should operate on a vserver or on the host.
+# In the former case, check that $vsname exists and is running.
 local usevserver=no
+local vroot
 if [ $vservers_are_available = yes ]; then
-   if ! vservers_exist "$vsname" ; then
-      fatal "At least one of the vservers listed in vsnames ($vsnames) does not exist."
-   else
-      info "using vserver '$vsname'"
+   if [ -n "$vsname" ]; then
+      # does it exist ?
+      if ! vservers_exist "$vsname" ; then
+         fatal "The vserver given in vsname ($vsname) does not exist."
+      fi
+      # is it running ?
+      $VSERVERINFO -q $vsname RUNNING
+      if [ $? -ne 0 ]; then
+         fatal "The vserver $vsname is not running."
+      fi
+      # everything ok
+      info "Using vserver '$vsname'."
       usevserver=yes
+      vroot="$VROOTDIR/$vsname"
+   else
+      info "No vserver name specified, actions will be performed on the host."
    fi
 fi
 
-# As needed, make sure that :
-#   * the specified vserver exists and is running
-#   * the specified vserver or host has the needed executables
+# Make sure that the system to backup has the needed executables
 if [ $usevserver = yes ]; then
-    info "examining vserver '$vsname'"
-    # does it exist ?
-    vroot="$VROOTDIR/$vsname"
-    [ -d $vroot ] || fatal "vserver '$vsname' does not exist at '$vroot'"
-    # is it running ?
-    running=`$VSERVERINFO $vsname RUNNING`
-    if [ "$running" = "1" ]; then
-       if [ "$databases" == "all" ]; then
-           [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMPALL`" ] || \
-               fatal "Can't find $PGSQLDUMPALL in vserver $vsname."
-       else
-           [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMP`" ] || \
-               fatal "Can't find $PGSQLDUMP in vserver $vsname."
-       fi
-    else
-       fatal "vserver $vsname is not running."
-    fi
+   debug "Examining vserver '$vsname'."
+   if [ "$databases" == "all" ]; then
+      [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMPALL`" ] || \
+        fatal "Can't find $PGSQLDUMPALL in vserver $vsname."
+   else
+      [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMP`" ] || \
+        fatal "Can't find $PGSQLDUMP in vserver $vsname."
+   fi
 else
-    if [ "$databases" == "all" ]; then
-       [ -x "`which $PGSQLDUMPALL`" ] || \
-           fatal "Can't find $PGSQLDUMPALL."
-    else
-       [ -x "`which $PGSQLDUMP`" ] || \
-           fatal "Can't find $PGSQLDUMP."
-    fi
+   if [ "$databases" == "all" ]; then
+      [ -x "`which $PGSQLDUMPALL`" ] || \
+        fatal "Can't find $PGSQLDUMPALL."
+   else
+      [ -x "`which $PGSQLDUMP`" ] || \
+        fatal "Can't find $PGSQLDUMP."
+   fi
 fi
 
 # create backup dir, the vroot variable will be empty if no vsname was specified
@@ -71,9 +72,9 @@ chmod 700 $vroot$backupdir
 # if $databases = all, use pg_dumpall
 if [ "$databases" == "all" ]; then
     if [ $usevserver = yes ]; then
-       execstr="$VSERVER $vsname exec su - postgres -c $PGSQLDUMPALL > $backupdir/${vsname}.sql"
+       execstr='$VSERVER $vsname exec su - postgres -c \"$PGSQLDUMPALL > $backupdir/${vsname}.sql\"'
     else
-       execstr="su - postgres -c $PGSQLDUMPALL > $backupdir/${localhost}-all.sql"
+       execstr='su - postgres -c \"$PGSQLDUMPALL > $backupdir/${localhost}-all.sql\"'
     fi
     debug "$execstr"
     if [ ! $test ]; then
@@ -93,9 +94,9 @@ else
     for db in $databases; do
        if [ $usevserver = yes ]
            then
-           execstr="$VSERVER $vsname exec su - postgres -c $PGSQLDUMP $db > $backupdir/${db}.sql"
+           execstr='$VSERVER $vsname exec su - postgres -c \"$PGSQLDUMP $db > $backupdir/${db}.sql\"'
        else
-           execstr="su - postgres -c $PGSQLDUMP $db > $backupdir/${db}.sql"
+           execstr='su - postgres -c \"$PGSQLDUMP $db > $backupdir/${db}.sql\"'
        fi
        debug "$execstr"
        if [ ! $test ]; then